﻿Imports C1.Win.FlexReport

Public Class Form1
    'Text Fields
    Dim tbTitle As Field, tbDebit As Field, tbCredit As Field, tbNumber As Field, tbName As Field, tbSiteHeader As Field, _
        tbNameCaption As Field, tbNumberCaption As Field, tbDebitCaption As Field, tbCreditCaption As Field
    Dim sitenumber As Integer

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cmbNoOfSites.SelectedIndex = 0
    End Sub

    Private Sub cmbNoOfSites_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbNoOfSites.SelectedIndexChanged
        'Number of Columns to Show
        sitenumber = Integer.Parse(cmbNoOfSites.SelectedItem.ToString())
        Dim sitequery As String = ""
        For i As Integer = 1 To sitenumber
            'Fetching only desired columns from Database
            sitequery = (sitequery & Convert.ToString("Site")) + i.ToString() + "Credit , Site" + i.ToString() + "Debit, "
        Next
        Dim sqlString As String = Convert.ToString("Select BranchID, BranchName, ") & sitequery
        sqlString = sqlString.Remove(sqlString.Length - 2, 1)
        sqlString += " FROM rptDB"

        CreateReport()
        C1FlexReport1.Layout.PaperSize = System.Drawing.Printing.PaperKind.A3
        C1FlexReport1.Layout.Orientation = OrientationEnum.Landscape

        'Assigning DataSource
        C1FlexReport1.DataSource.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + "\..\..\FlexrptDB.mdb;Persist Security Info=False"
        C1FlexReport1.DataSource.RecordSource = sqlString
        C1FlexReport1.DataSource.DataProvider = DataProvider.OLEDB
        C1FlexViewer1.DocumentSource = C1FlexReport1
    End Sub

    Private Sub CreateReport()
        C1FlexReport1.Clear()

        'Height(landscape) of a A3 Page
        C1FlexReport1.Layout.Width = 16.53 * 1440

        ' create a report header    
        Dim sHeader As Section = C1FlexReport1.Sections(SectionTypeEnum.Header)
        sHeader.Height = 1.5 * 1440
        sHeader.Visible = True

        'Title Field
        tbTitle = New Field()
        tbTitle.Name = "FldTitle"
        tbTitle.Text = "Dynamic Report"
        tbTitle.Left = 0
        tbTitle.Top = 0
        tbTitle.BackColor = Color.LightCyan
        tbTitle.Width = C1FlexReport1.Layout.Width - C1FlexReport1.Layout.MarginRight - C1FlexReport1.Layout.MarginLeft
        tbTitle.Height = 1440
        tbTitle.Align = FieldAlignEnum.CenterMiddle
        tbTitle.Font.Size = 25.0F
        tbTitle.Font.Bold = True
        tbTitle.ForeColor = Color.FromArgb(0, 0, 100)
        sHeader.Fields.Add(tbTitle)

        If sitenumber > 0 Then
            ' create a page footer
            Dim sPageHeader As Section = C1FlexReport1.Sections(SectionTypeEnum.PageHeader)
            sPageHeader.Height = 0.65 * 1440
            sPageHeader.Visible = True

            tbNumberCaption = New Field()
            tbNumberCaption.Name = "tbNumberCaption"
            tbNumberCaption.Text = "Num"
            tbNumberCaption.BackColor = Color.FromArgb(200, 200, 200)
            tbNumberCaption.Left = 0
            tbNumberCaption.Top = 0.3 * 1440
            tbNumberCaption.Width = 0.8 * 1440
            tbNumberCaption.Height = 0.3 * 1440
            tbNumberCaption.Align = FieldAlignEnum.CenterMiddle
            tbNumberCaption.Border = New C1.Win.C1Document.Border(30.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
            tbNumberCaption.Font.Size = 15.0F
            tbNumberCaption.Font.Bold = True
            sPageHeader.Fields.Add(tbNumberCaption)

            tbNameCaption = New Field()
            tbNameCaption.Name = "tbNameCaption"
            tbNameCaption.Text = "Name"
            tbNameCaption.BackColor = Color.FromArgb(200, 200, 200)
            tbNameCaption.Left = 0.8 * 1440
            tbNameCaption.Top = 0.3 * 1440
            tbNameCaption.Width = 0.8 * 1440
            tbNameCaption.Height = 0.3 * 1440
            tbNameCaption.Align = FieldAlignEnum.CenterMiddle
            tbNameCaption.Border = New C1.Win.C1Document.Border(30.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
            tbNameCaption.Font.Size = 15.0F
            tbNameCaption.Font.Bold = True
            sPageHeader.Fields.Add(tbNameCaption)

            'Calculating the available width to decide Column's Width
            Dim GrosspageWidth As Double = C1FlexReport1.Layout.Width - tbNameCaption.Width - tbNumberCaption.Width - C1FlexReport1.Layout.MarginLeft - C1FlexReport1.Layout.MarginRight
            Dim fieldWidth As Double = GrosspageWidth / (sitenumber * 2)

            Dim sDetail As Section = C1FlexReport1.Sections(SectionTypeEnum.Detail)
            sDetail.Height = 0.4 * 1440
            sDetail.AutoHeight = AutoSizeBehavior.GrowAndShrink
            sDetail.Visible = True

            tbNumber = New Field()
            tbNumber.Name = "tbNumber"
            tbNumber.Text = "BranchID"
            tbNumber.Calculated = True
            tbNumber.Left = 0
            tbNumber.Top = 0
            tbNumber.Width = 0.8 * 1440
            tbNumber.Height = 0.4 * 1440
            tbNumber.Align = FieldAlignEnum.CenterMiddle
            tbNumber.Border = New C1.Win.C1Document.Border(15.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
            tbNumber.Font.Size = 12.0F
            sDetail.Fields.Add(tbNumber)

            tbName = New Field()
            tbName.Name = "tbName"
            tbName.Text = "BranchName"
            tbName.Calculated = True
            tbName.Left = 0.8 * 1440
            tbName.Top = 0
            tbName.Width = 0.8 * 1440
            tbName.Height = 0.4 * 1440
            tbName.Align = FieldAlignEnum.CenterMiddle
            tbName.Border = New C1.Win.C1Document.Border(15.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
            tbName.Font.Size = 12.0F
            sDetail.Fields.Add(tbName)

            For i As Integer = 1 To sitenumber
                'Dynamic Column Captions
                tbSiteHeader = New Field()
                tbSiteHeader.Name = "SiteHeader" + (i).ToString()
                tbSiteHeader.Text = "Site" + (i).ToString()
                tbSiteHeader.BackColor = Color.FromArgb(200, 200, 200)
                tbSiteHeader.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2)
                tbSiteHeader.Top = 0
                tbSiteHeader.Width = fieldWidth * 2
                tbSiteHeader.Height = 0.3F * 1440
                tbSiteHeader.Align = FieldAlignEnum.CenterMiddle
                tbSiteHeader.Border = New C1.Win.C1Document.Border(30.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
                tbSiteHeader.Font.Size = 15.0F
                tbSiteHeader.Font.Bold = True
                sPageHeader.Fields.Add(tbSiteHeader)

                tbDebitCaption = New Field()
                tbDebitCaption.Name = "Site" + (i).ToString() + "DebitCaption"
                tbDebitCaption.Text = "Debit"
                tbDebitCaption.BackColor = Color.FromArgb(200, 200, 200)
                tbDebitCaption.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2)
                tbDebitCaption.Top = 0.3 * 1440
                tbDebitCaption.Width = fieldWidth
                tbDebitCaption.Height = 0.3F * 1440
                tbDebitCaption.Align = FieldAlignEnum.CenterMiddle
                tbDebitCaption.Border = New C1.Win.C1Document.Border(30.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
                tbDebitCaption.Font.Size = 15.0F
                tbDebitCaption.Font.Bold = True
                sPageHeader.Fields.Add(tbDebitCaption)

                tbCreditCaption = New Field()
                tbCreditCaption.Name = "Site" + (i).ToString() + "CreditCaption"
                tbCreditCaption.Text = "Credit"
                tbCreditCaption.BackColor = Color.FromArgb(200, 200, 200)
                tbCreditCaption.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2) + fieldWidth
                tbCreditCaption.Top = 0.3 * 1440
                tbCreditCaption.Width = fieldWidth
                tbCreditCaption.Height = 0.3F * 1440
                tbCreditCaption.Align = FieldAlignEnum.CenterMiddle
                tbCreditCaption.Border = New C1.Win.C1Document.Border(30.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
                tbCreditCaption.Font.Size = 15.0F
                tbCreditCaption.Font.Bold = True
                sPageHeader.Fields.Add(tbCreditCaption)

                'Dynamic Columns
                tbDebit = New Field()
                tbDebit.Name = "Site" + (i).ToString() + "Debit"
                tbDebit.Text = "Site" + i.ToString() + "Debit"
                tbDebit.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2)
                tbDebit.Top = 0
                tbDebit.Width = fieldWidth
                tbDebit.Height = 0.4F * 1440
                tbDebit.Calculated = True
                tbDebit.Align = FieldAlignEnum.CenterMiddle
                tbDebit.Border = New C1.Win.C1Document.Border(15.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
                tbDebit.Font.Size = 12.0F
                sDetail.Fields.Add(tbDebit)

                tbCredit = New Field()
                tbCredit.Name = "Site" + (i).ToString() + "Debit"
                tbCredit.Text = "Site" + (i).ToString() + "Credit"
                tbCredit.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2) + fieldWidth
                tbCredit.Top = 0
                tbCredit.Width = fieldWidth
                tbCredit.Height = 0.4F * 1440
                tbCredit.Calculated = True
                tbCredit.Align = FieldAlignEnum.CenterMiddle
                tbCredit.Border = New C1.Win.C1Document.Border(15.0F, Color.Black, C1.Win.C1Document.DashStyle.Solid)
                tbCredit.Font.Size = 12.0F
                sDetail.Fields.Add(tbCredit)
            Next
        End If
    End Sub

End Class
